<?php
/***************************************************************************
 *                             module_resync.php
 *                            -------------------
 *   begin                : Saturday, Dec 15, 2006
 *   copyright            : (C) 2006 AmigaLink
 *   website              : www.AmigaLink.de
 *
 *   $Id: admin_cache_posts.php v 0.6.1 2007/01/14 08:38:00 oxpus Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *  This hack is released under the GPL License V2. 
 *  This hack can be freely used, but not distributed, without permission.
 *  Intellectual Property Rights are retained by the hack author(s) 
 *  listed above.
 *  If you change this hack or use some code parts in your work. You MUST give
 *  full information about the original author(s) and website(s) listed above.
 *
 ***************************************************************************/

define('IN_PHPBB', true);

if ( !empty($cps_module_init) )
{
	$cps_module_file = basename(__FILE__);
	$cps_module[] = array(
		'name' => str_replace('.'.$phpEx, '', str_replace('cps-module_', '', $cps_module_file)),
		'file' => $cps_module_file
	);
	return;
}

//
// Load default header
//
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin_cache_posts.' . $phpEx);


$cached_posts_array = array();
$files_cache = glob($phpbb_root_path.'cache/posts/*post_*.gz');  
if ($files_cache)  
{  
	foreach ($files_cache as $cachefile)  
	{  
		$cached_posts_array[] = substr(str_replace('.gz', '', str_replace($phpbb_root_path.'cache/posts/', '', $file)), strrpos(str_replace('.gz', '', str_replace($phpbb_root_path.'cache/posts/', '', $file)), '_')+1 );  
	}  
}
sort($cached_posts_array);
$cached_posts = implode(",", array_unique($cached_posts_array));
$sql2 = ($cached_posts) ? " NOT IN ($cached_posts)" : '';

$sql = "UPDATE " . POSTS_TABLE . "
	SET parsed = 0, cache_file_md5 = NULL 
	WHERE post_id".$sql2;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
}

$corrected = $db->sql_affectedrows($result);

for ($i = 0; $i <= count($cached_posts_array)-1; $i++)
{
	$cachefile = $phpbb_root_path.'cache/posts/post_'.$cached_posts_array[$i].'.gz';
	if ($cached_posts_array[$i])
	{
		$sql = "UPDATE " . POSTS_TABLE . "
		SET parsed = 1, cache_file_md5 = '" . md5_file($cachefile) . "' , dont_cache = 0
		WHERE post_id = $cached_posts_array[$i]
			AND parsed = 0";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
		}
		$corrected = $corrected + $db->sql_affectedrows($result);
	}
}

for ($i = 0; $i <= count($cached_posts_array)-1; $i++)
{
	$cachefile = $phpbb_root_path.'cache/posts/post_'.$cached_posts_array[$i].'.gz';
	$sql = "UPDATE " . POSTS_TABLE . "
		SET parsed = 1, cache_file_md5 = '" . md5_file($cachefile) . "' , dont_cache = 0 
		WHERE post_id = $cached_posts_array[$i] 
			AND dont_cache = 1";
	if(!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
	}
	$corrected = $corrected + $db->sql_affectedrows($result);
}

$sql = "UPDATE " . POSTS_TABLE . "
	SET parsed = 0, cache_file_md5 = NULL 
	WHERE dont_cache = 1";
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
}
$corrected = $corrected + $db->sql_affectedrows($result);

$message = '<br />' . $corrected . $lang['resync_done'] . '<br /><br />' . sprintf($lang['Click_return_cps'], '<a href="' . append_sid("admin_cache_posts.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf($lang['Click_return_admin_index'], '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>') . '<br /><br />';
message_die(GENERAL_MESSAGE, $message);

?>